import React, { useState } from 'react';
import './index.less';
import { Button, Form, message, Modal } from 'antd';
import { PlusOutlined } from '@ant-design/icons';
import FacilitysTow from './FacilitysTow';
import { Link, useIntl, connect, Dispatch, history } from 'umi';

function getBase64(file) {
  return new Promise((resolve, reject) => {
    const reader = new FileReader();
    reader.readAsDataURL(file);
    reader.onload = () => resolve(reader.result);
    reader.onerror = (error) => reject(error);
  });
}
const Facilitys = (props: any) => {
  //传递值
  const { updata, disabled } = props;

  return (
    <>
      <Form.List
        name="picList"
        rules={[
          {
            validator: async (_, names) => {
              // if (!names || names.length < 2) {
              //   return Promise.reject(new Error('At least 2 passengers'));
              // }
            },
          },
        ]}
      >
        {(fields, { add, remove }, { errors }) => (
          <>
            {fields.map((field, index) => (
              <Form.Item required={false} key={field.key} style={{ marginBottom: 0 }}>
                <FacilitysTow updata={updata} disabled={disabled} keys={field.key}></FacilitysTow>
              </Form.Item>
            ))}
            {fields.length < 5 ? (
              <Form.Item>
                <Button
                  type="dashed"
                  onClick={() => add()}
                  style={{ width: '100px', height: '100px' }}
                  icon={<PlusOutlined />}
                  disabled={disabled}
                ></Button>
                <Form.ErrorList errors={errors} />
              </Form.Item>
            ) : null}
          </>
        )}
      </Form.List>
    </>
  );
};

function mapStateToProps(state: any) {
  const { imgList } = state.FacilityBookings;
  return {
    imgList,
  };
}
export default connect(mapStateToProps)(Facilitys);
