import React, { useState, useEffect, useRef } from 'react';
import './index.less';
import { Input, Upload, Form, Select, message, Modal } from 'antd';
const { Option } = Select;
import { PlusOutlined } from '@ant-design/icons';
import { Link, useIntl, connect, Dispatch, history } from 'umi';

function getBase64(file) {
  return new Promise((resolve, reject) => {
    const reader = new FileReader();
    reader.readAsDataURL(file);
    reader.onload = () => resolve(reader.result);
    reader.onerror = (error) => reject(error);
  });
}

const module = 'FacilityBookings';

const FacilitysTow = (props: any) => {
  const { updata, disabled, keys, dispatch } = props;

  //上传列表
  const [fileList, setFileList] = useState([]);
  //显示隐藏
  const [previewVisible, setpreviewVisible] = useState(false);
  // 名称
  const [previewTitle, setpreviewTitle] = useState('');
  // 图片地址
  const [previewImage, setpreviewImage] = useState('');

  // 新增按钮
  const uploadButton = (
    <div>
      <PlusOutlined />
      <div className="ant-upload-text">Upload</div>
    </div>
  );

  // 上传属性
  const uploadProps = {
    listType: 'picture-card',
    accept: '.jpeg,.png,.jpg',
    action: '/tos/image/upload',
    // fileList: fileList,
    onChange(info: any) {
      console.log(info);
      if (info.file.status === 'done') {
        message.success(`${info.file.name} file uploaded successfully`);
        // 拿到key 值  开始存储
        // let key = info.fileList[0].response.data.identification;
        // let list = fileList;
        // list[key] = info.fileList;
        // setFileList(list);      // 注意 不能直接赋值  因为使用完全绑定需要全部更新

        // setFileList(list);
        let list: any = [...fileList, ...info.fileList];
        setFileList(list);

        console.log(info);
        // 将图片信息提交给state
        let data = { val: info.file.name, key: keys };
        dispatch({ type: module + '/retImgsList', data });
        // 结束
      } else if (info.file.status === 'error') {
        message.error(`${info.file.name} file upload failed.`);
      }
    },
  };

  // 预览
  const handlePreview = async (file) => {
    if (!file.url && !file.preview) {
      file.preview = await getBase64(file.originFileObj);
    }
    setpreviewImage(file.url || file.preview);
    setpreviewTitle(file.name);
    setpreviewVisible(true);
  };

  // 点击遮罩回调
  const handleCancel = () => {
    setpreviewVisible(false);
  };

  // 点击移除图片
  const handRemove = () => {
    // let list = fileList;
    setFileList([]);
    // 将图片信息提交给state
    let data = { key: keys };
    dispatch({ type: module + '/overImgList', data });
  };

  // 输入框内容
  const monitor = (e: any) => {
    let data = { val: e.target.value, key: keys };
    dispatch({ type: module + '/retImgsName', data });
  };

  return (
    <div>
      {}
      {/* 每一个上传的组件 */}
      <div className={'test'}>
        <div className={'diybox'}>
          <Upload
            fileList={fileList}
            data={updata}
            {...uploadProps}
            disabled={disabled}
            onPreview={handlePreview}
            onRemove={handRemove}
          >
            {/* 这里存在一个bug  当 key 超过 fileList 的默认值后 会报错 */}
            {fileList.length >= 1 ? null : uploadButton}
          </Upload>

          <div className={'Facility'}>
            <Form.Item
              label={`Facility Name ${keys}`}
              name={keys.key}
              rules={[{ required: true, message: 'Please input Facility Name!' }]}
            >
              <Input placeholder="Facility Name" onChange={monitor} disabled={disabled} />
            </Form.Item>
            <div className={'over'}>
              {/* {fields.length > 1 ? (
                <Button type="link" disabled={disabled} onClick={() => remove(field.name)}>
                  Delete
                </Button>
              ) : null} */}
            </div>
          </div>
        </div>
      </div>

      {/* 预览表格 */}
      <Modal visible={previewVisible} title={previewTitle} footer={null} onCancel={handleCancel}>
        <img alt="example" style={{ width: '100%' }} src={previewImage} />
      </Modal>
    </div>
  );
};

function mapProps(state: any) {
  console.log(state.FacilityBookings);
  console.log('------------------');
  const { imgList } = state.FacilityBookings;
  return {
    imgList,
  };
}
export default connect(mapProps)(FacilitysTow);
