import React, { useState, useEffect, useRef } from 'react';
import styles from './css/Bookings.less';
import './css/Bookings.less';
import {
  Spin,
  Input,
  DatePicker,
  Button,
  Form,
  Radio,
  TimePicker,
  Row,
  Col,
  message,
  Result,
} from 'antd';
const { RangePicker } = TimePicker;

import { DollarOutlined, ClockCircleOutlined } from '@ant-design/icons';

import { connect } from 'umi';

import TitleBack from '../../../components/TitleBack/TitleBack';
import SearchOptionsCommnity from '../../../components/SearchOptions/SearchOptionsCommnity';

import { numberToString } from '../../../utils/string';
import { checkData, checkInput } from '@/utils/method';
import { validateMessages } from '@/utils/params';

// 日期
import moment from 'moment';
import { BookingsTip } from '@/utils/tip';

const Bookings = (props: any) => {
  const { dispatch, Data3, Result, DataSave, token, load } = props;

  const RA = (index: any, values: any) => {
    dispatch({ type: 'FacilityBookings/RA', playload: { index: index, body: values } });
  };
  const IA = () => {
    dispatch({ type: 'FacilityBookings/IA' });
  };
  const SAClear = () => {
    dispatch({ type: 'FacilityBookings/SA', playload: null });
  };
  const ResultClear = () => {
    dispatch({ type: 'FacilityBookings/ResultClear' });
  };

  const [comminityValues, setComminityValues] = useState(null);
  const [curString, setCurString] = useState({
    communityManagerFee: null,
    communityMargin: null,
    categoriesOpenTime: null,
  } as any);
  const [loading, setLoading] = useState(false);
  const formRef = useRef(null);

  // 是否不可选
  const [prohibit, setProhibit] = useState(true);

  console.log(curString);

  useEffect(() => {
    if (DataSave != null) {
      console.log('页面进入参数');
      console.log(DataSave);
      setComminityValues(DataSave.communityName);
      RA(1, { userToken: token, communityName: DataSave.communityName, facilitieId: DataSave.id });
    }
  }, [DataSave]);

  useEffect(() => {
    IA();
  }, []);

  useEffect(() => {
    if (Result != null) {
      console.log(Result);
      message.error(Result.msg);
      if (Result.index == 1) {
        IA();
      }
      setLoading(false);
      ResultClear();
    }
  }, [Result]);

  // 选择小区监听是不是有值
  useEffect(() => {
    setLoading(false);
    console.log(Data3);
    if (!Data3) {
      // 如果没有值 要把Data3 从 false  复原成  null   并提示
      dispatch({ type: 'FacilityBookings/returnPage3' });
    }
  }, [Data3]);

  const format = 'HH:mm';

  const checkParam = (values: any) => {
    var flag = true;

    for (var i in values) {
      // console.log(values[i]);
      if (values[i] == null) {
        flag = false;
      } else {
        if (values[i].length == 0) {
          flag = false;
        }
      }
    }
    return flag;
  };

  const onFinish = (value: any) => {
    console.log('Success:');
    var tmp = value;
    console.log(value);
    // tmp.categoriesId = null
    // tmp.facilitiesId = null
    // tmp.communityName = null
    // tmp.communityManagerFee = null
    // tmp.communityMargin=null
    if (value.categoriesName != null) {
      tmp.categoriesId = value.categoriesName.categoriesId;
      tmp.facilitiesId = value.categoriesName.facilitiesId;
      tmp.categoriesName = value.categoriesName.categoriesName;
    }
    if (value.subscribeDate != null) {
      tmp.subscribeDate = value.subscribeDate.format('YYYY-M-D');
    }
    if (value.reservedTimeList != null) {
      tmp.reservedTimeList = [
        value.reservedTimeList[0].format('HH:mm'),
        value.reservedTimeList[1].format('HH:mm'),
      ];
    }
    if (comminityValues != null) {
      tmp.communityName = comminityValues;
    }
    if (curString != null) {
      tmp.communityManagerFee = numberToString(curString.communityManagerFee);
      tmp.communityMargin = numberToString(curString.communityMargin);
    }
    if (tmp.accountName.length < 2) {
      message.error('User Name Should be limit 2~30!', 3);
    } else {
      //还差检测
      if (checkParam(tmp)) {
        console.log(tmp);
        RA(11, tmp);
      } else {
        message.error('Error,Please finish it,not empty!', 3);
      }
    }
    // console.log(checkParam(tmp))
    // console.log(comminityValues)
    // console.log(tmp)
  };
  const RadioChoose = (e: any) => {
    Data3.map((item: any, index: any) => {
      item.categorieList.map((thing: any, i: any) => {
        if (thing.categoriesId == e.target.value.categoriesId) {
          setCurString({
            communityManagerFee: parseInt(item.communityManagerFee).toFixed(2),
            communityMargin: parseInt(item.communityMargin).toFixed(2),
            categoriesOpenTime: item.categoriesOpenTime,
            id: item.facilitiesId,
          });

          // 选择后取消输入框禁止
          setProhibit(false);

          // console.log(item.communityManagerFee)
          // console.log(item.communityMargin)
        }
      });
    });
  };

  // 选择小区名字发起请求
  const getFacility = (values: any) => {
    SAClear();
    setComminityValues(values);
    console.log(values);
    RA(1, { userToken: token, communityName: values });
    setLoading(true);
  };

  // 设置之前时间不能选择
  function disabledDate(current: any) {
    return current && current <= moment().subtract(1, 'days').endOf('day');
  }

  // 确认日期
  const confirmData = (value: any) => {
    console.log(value);
  };

  return (
    <div className={styles.base}>
      {/* 头部组件v1.2 */}
      <TitleBack title="Facility Bookings" />

      <div className={styles.box1}>
        <div className={styles.box1item1}>Project : </div>
        <div className={styles.box1item2}>
          <Spin spinning={loading} tip="Finding...">
            <SearchOptionsCommnity
              alone={true}
              placeholder={'Community Name'}
              opname={getFacility}
              defaultValue={DataSave != null ? DataSave.communityName : null}
              // onSubmit={getFacility}
            />
          </Spin>
          {/* <Input.Search style={{ width: 200, height: 32 }} onSearch={getFacility} loading={loading} defaultValue={}/> */}
        </div>
      </div>
      {Data3 ? (
        <>
          <Form ref={formRef} name="basic" onFinish={onFinish} validateMessages={validateMessages}>
            <div className={styles.box2}>
              <div className={styles.box2item1}>Facility Bookings : </div>
              <div className={styles.box2item2}>
                <Form.Item name="categoriesName">
                  <Radio.Group defaultValue={1} onChange={RadioChoose}>
                    {Data3.map((item: any, index: any) => {
                      var tmp = new Array();
                      item.categorieList.map((thing: any, i: any) => {
                        tmp.push(
                          <Radio key={thing.categoriesId} value={thing}>
                            {thing.categoriesName}
                          </Radio>,
                        );
                      });
                      return tmp;
                    })}
                  </Radio.Group>
                </Form.Item>
              </div>
            </div>
            <div className={styles.line}></div>

            <div className={styles.box3}>
              <div className={styles.box3item1}>User Name : </div>
              <div className={styles.box3item2}>
                <Form.Item name="accountName" rules={BookingsTip[0]}>
                  <Input
                    style={{ width: 200 }}
                    placeholder="Name Of Subscriber"
                    disabled={prohibit}
                  />
                </Form.Item>
              </div>
              <div className={styles.box3item3}>Contact Details : </div>
              <div className={styles.box3item4}>
                <Form.Item name="accountPhone" rules={BookingsTip[1]}>
                  <Input
                    style={{ width: 200 }}
                    placeholder="Contact Information"
                    disabled={prohibit}
                  />
                </Form.Item>
              </div>
            </div>

            <div className={styles.box4}>
              <div className={styles.box4item1}>Unit : </div>
              <div className="divbox4">
                <Form.Item name="buildNumber" rules={BookingsTip[2]}>
                  <Input placeholder="Building" style={{ width: 80 }} disabled={prohibit} />
                </Form.Item>
                <span className="jio">#</span>
                <Form.Item name="floorNumber" rules={BookingsTip[3]}>
                  <Input placeholder="Floor" style={{ width: 80 }} disabled={prohibit} />
                </Form.Item>
                <span className="heng">--</span>
                <Form.Item name="roomNumber" rules={BookingsTip[4]}>
                  <Input placeholder="Room" style={{ width: 80 }} disabled={prohibit} />
                </Form.Item>
              </div>
            </div>
            <div className={styles.line}></div>

            <div className={styles.box5}>
              <div className={styles.box5item1}>Booking Schedule : </div>
              <div className={styles.box5item2}>
                <Row gutter={8}>
                  <Col>
                    <Form.Item name="subscribeDate" rules={BookingsTip[5]}>
                      <DatePicker
                        placeholder="Select Date"
                        disabledDate={disabledDate}
                        onChange={confirmData}
                        disabled={prohibit}
                      />
                    </Form.Item>
                  </Col>
                  <Col>
                    <Form.Item name="reservedTimeList" rules={BookingsTip[6]}>
                      <RangePicker
                        placeholder={['Start Time', 'End Time']}
                        format={format}
                        disabled={prohibit}
                      />
                    </Form.Item>
                  </Col>
                </Row>
              </div>
            </div>
            {curString.communityManagerFee != null ? (
              <>
                <div className={styles.box6}>
                  <div className={styles.box6item1}>Management fee required : </div>
                  <div className={styles.box6item2}>
                    <DollarOutlined style={{ color: '#999' }} /> {curString.communityManagerFee}
                  </div>
                </div>

                <div className={styles.box6}>
                  <div className={styles.box6item1}>Deposit is required : </div>
                  <div className={styles.box6item2}>
                    <DollarOutlined style={{ color: '#999' }} /> {curString.communityMargin}
                  </div>
                </div>

                <div className={styles.box6}>
                  <div className={styles.box6item1}>Opening Hours : </div>
                  <div className={styles.box6item2}>
                    <ClockCircleOutlined style={{ color: '#999' }} /> {curString.categoriesOpenTime}
                  </div>
                </div>
              </>
            ) : null}

            <div className={styles.line}></div>
            <Button
              htmlType="submit"
              type="primary"
              loading={false}
              style={{ width: 80, height: 32 }}
            >
              Submit
            </Button>
          </Form>
        </>
      ) : null}
    </div>
  );
};

function mapStateToProps(state: any) {
  const { Data3, Result, DataSave } = state.FacilityBookings;
  const { token } = state.login;
  return {
    Data3,
    Result,
    DataSave,
    token,
  };
}
export default connect(mapStateToProps)(Bookings);
